%%
%  Author: Peter Polcz (ppolcz@gmail.com) 
%  Created on 2023. November 09. (2023a)

Color_1 = [0 0.4470 0.7410];
Color_2 = [0.8500 0.3250 0.0980];
Color_3 = [0.9290 0.6940 0.1250];
Color_4 = [0.4940 0.1840 0.5560];
Color_5 = [0.4660 0.6740 0.1880];
Color_6 = [0.3010 0.7450 0.9330];
Color_7 = [0.6350 0.0780 0.1840];

fig = figure(2);
delete(fig.Children)
Tl = tiledlayout(2,2,"TileSpacing","compact","Padding","tight","TileIndexing","rowmajor");

%%

Ax_Bif = nexttile(2);
hold on; grid on; box on;

X = [];
Y = [];

for mu = linspace(1,4,301)
    f = @(x) mu*(x - x.^2);
    
    N0 = 1000;
    N = 5000;
    x = [ 0.5 zeros(1,N-1) ];
    
    for k = 1:N-1
        x(k+1) = f(x(k));
    end
    
    w = limit_points(x(N0:end));

    X = [X ; w(:)*0+mu];
    Y = [Y ; w(:)];
end

Pl_Bif = plot(X,Y,'.');
Pl_mu = plot([0,0],[0,1],'r','LineWidth',2);

%%

Ax_Bif = nexttile(1);
hold on; grid on; box on;

t = 0:0.01:1;
plot(t,t,'Color','black','LineWidth',1.5);
Pl_f = plot(t,f(t),'Color','black','LineWidth',1.5);

[X,Y] = plotXY(x,f);
Pl_WEB = plot(X,Y,'Color',Color_1);

[X,Y] = plotXY(x(N0:end),f);
Pl_W = plot(X(2:end),Y(2:end),'Color',Color_2,'LineWidth',2);

Felosztas = 0:0.01:1;
Ax_Hist = nexttile(3);
Pl_Hist = histogram(x(N0:end),Felosztas);


Ax_PLOT = nexttile;
Pl_idofv = plot(1:N,x);
xlim([0,50])

tic
for mu = [ linspace(0,1,51) linspace(1,3.5,301) linspace(3.5,4,301) ];
    f = @(x) mu*(x - x.^2);
    
    N0 = 1000;
    N = 5000;
    x = [ 0.999 zeros(1,N-1) ];
    
    for k = 1:N-1
        x(k+1) = f(x(k));
    end
    w = limit_points(x(N0:end));

    Pl_f.YData = f(t);
    [Pl_WEB.XData,Pl_WEB.YData] = plotXY(x,f);
    [Pl_W.XData,Pl_W.YData] = plotXY(x(N0:end),f);
    
    Pl_mu.XData = mu*[1,1];
    Pl_Hist = histogram(Ax_Hist,x(N0:end),Felosztas);

    Pl_idofv.YData = x;

    pause(0.1-toc)
    tic

    % if ismember(mu,[2,3,3.5,3.7,3.83,3.9])
    %     keyboard
    % end
end

function [X,Y] = plotXY(x,f)
    N = numel(x);
    X = reshape([1;1]*x, [2*N 1]);
    Y = reshape([ 0 f(x(1:end-1)) ; f(x) ],[2*N 1]);
end

function w = limit_points(x)
    w = unique(round(x,10));
end